import 'uno.css';
import '@/design/index.less';
import '@/components/VxeTable/src/css/index.scss';
import 'ant-design-vue/dist/reset.css';
// Register icon sprite
import 'virtual:svg-icons-register';

import { createApp } from 'vue';

import { registerGlobComp } from '@/components/registerGlobComp';
import { setupGlobDirectives } from '@/directives';
import { setupI18n } from '@/locales/setupI18n';
import { setupErrorHandle } from '@/logics/error-handle';
import { initAppConfigStore } from '@/logics/initAppConfig';
import { router, setupRouter } from '@/router';
import { setupRouterGuard } from '@/router/guard';
import { setupStore } from '@/store';

import VideoPlayer from 'vue-video-player';
import 'vue-video-player/src/custom-theme.css';

import App from './App.vue';

import 'mars3d-cesium/Build/Cesium/Widgets/widgets.css';
import 'mars3d/dist/mars3d.css';

import ElementPlus from 'element-plus';
import 'element-plus/theme-chalk/index.css';
import VForm3 from '@/../lib/vform/designer.umd.js';
import '../lib/vform/designer.style.css';

import 'bpmn-js/dist/assets/diagram-js.css';
import 'bpmn-js/dist/assets/bpmn-font/css/bpmn-embedded.css';

import Antd from 'ant-design-vue';
import { signal } from './utils/signalR';

async function bootstrap() {
  const app = createApp(App);
  app.use(Antd);

  // Configure store
  // 配置 store
  setupStore(app);

  // Initialize internal system configuration
  // 初始化内部系统配置
  initAppConfigStore();

  // Register global components
  // 注册全局组件
  registerGlobComp(app);

  // Multilingual configuration
  // 多语言配置
  // Asynchronous case: language files may be obtained from the server side
  // 异步案例：语言文件可能从服务器端获取
  await setupI18n(app);

  // Configure routing
  // 配置路由
  setupRouter(app);

  // router-guard
  // 路由守卫
  setupRouterGuard(router);

  // Register global directive
  // 注册全局指令
  setupGlobDirectives(app);

  // Configure global error handling
  // 配置全局错误处理
  setupErrorHandle(app);

  // https://next.router.vuejs.org/api/#isready
  // await router.isReady();

  app.use(ElementPlus);
  app.use(VForm3);
  app.use(VideoPlayer);
  app.use(signal);
  app.mount('#app');
}

bootstrap();
